jQuery(document).ready(
	function ($) {

		var ajaxurl = af_wuc_link_obj.ajax_url;
		var nonce = af_wuc_link_obj.af_wuc_form_data_nonce;
		jQuery('.af-wuc-product-live-search').select2(
			{
				// console.log('here');
				ajax: {
					url: ajaxurl, // AJAX URL is predefined in WordPress admin.
					dataType: 'json',
					type: 'POST',
					delay: 20, // Delay in ms while typing when to perform a AJAX search.
					data: function (params) {
						// console.log(params);
						return {
							q: params.term, // search query
							action: 'af_wuc_product_search', // AJAX action for admin-ajax.php.//aftaxsearchUsers(is function name which isused in adminn file)
							nonce: nonce // AJAX nonce for admin-ajax.php.
						};
					},
					processResults: function (data) {
						console.log(data);
						var options = [];
						if (data) {
							// data is the array of arrays, and each of them contains ID and the Label of the option.
							$.each(
								data,
								function (index, text) {
									// do not forget that "index" is just auto incremented value.
									options.push({ id: text['id'], text: text['name'], });
								}
							);
						}
						return {
							results: options
						};
					},
					cache: true
				},
				multiple: true,
				placeholder: 'Choose Products',
				minimumInputLength: 3,
				width: '100%'  // the minimum of symbols to input before perform a search.
			}
		);

		// $( '.af_wuc_multi_select_products' ).select2();
		$('.af_wuc_select_countries').select2();
		console.log(af_wuc_link_obj);

		$('#af_wuc_add_quantity_for_product').on(
			'click',
			function () {

				var af_wuc_array = [];

				$('.af_wuc_multi_select_products').find('option:selected').each(
					function () {
						af_wuc_array.push(
							{
								'product_id': $(this).val(),
								'product_name': $(this).text(),
								'product_type': $(this).data('product-type'),
								'product_attributes': $(this).data('product-attributes'),
								'product_variations': $(this).data('product-variations')
							}
						);
					}
				);

				if (!af_wuc_array.length) {
					alert('Please Select at least one Product');
					return false;
				}
				for (var index in af_wuc_array) {
					var item = af_wuc_array[index];

					if ($('.af_wuc_prod_quantity_' + item.product_id).length === 0) {

						var form_data = new FormData();
						form_data.append('action', 'af_wuc_get_product_attributes');
						form_data.append('product_id', item.product_id);
						form_data.append('nonce', af_wuc_link_obj.af_wuc_form_data_nonce);

						$.ajax(
							{
								type: 'POST',
								url: af_wuc_link_obj.ajax_url,
								data: form_data,
								processData: false,
								contentType: false,
								dataType: 'json',
								success: function (response) {
									$('.af-wuc-table').closest('div').removeClass('af-wuc-hide-table');
									$('.af-wuc-table').find('tbody').append(response.data.af_wuc_message);
									$('.af_wuc_url_tr').toggle($('table.af-wuc-table tbody tr').length > 0);
									$('#publish').toggle($('table.af-wuc-table tbody tr').length > 0);
								}
							}
						);
					}
				}
				$('.af_wuc_multi_select_products').find('option:selected').each(
					function () {
						$(this).prop('selected', false);
					}
				);

				$('.af_wuc_multi_select_products').trigger('change');

			}
		);

		$(document).on(
			'click',
			'.af_wuc_check_orders',
			function () {
				$('.af_wuc_check_orders').siblings('table').addClass('af_wuc_hide');
				$('.af_wuc_check_orders').siblings('.af_wuc_order_table_overlay').addClass(" af_wuc_hide");
				// console.log($(this).siblings());
				$(this).siblings('section').removeClass('af_wuc_hide');
				$(this).siblings('.af_wuc_order_table_overlay').removeClass(" af_wuc_hide");

			}
		);

		$(document).on(
			"click",
			".af_wuc_order_table_btn_close",
			function () {
				$(this).closest('section').addClass("af_wuc_hide");
				$(this).closest('section').siblings(".af_wuc_order_table_overlay").addClass(" af_wuc_hide");
			}
		);

		$('.af_wuc_url_tr').toggle($('table.af-wuc-table tbody tr').length > 0);
		$('#publish').toggle($('table.af-wuc-table tbody tr').length > 0);


		$(document).on(
			'change',
			'.af_wuc_product_attribute',
			function () {
				var current_element = $(this);
				var current_select_value = $(this).val();
				var current_select_name = 'attribute_' + $(this).attr('data-label');
				$(this).attr('data-value', $(this).val());
				var $current_element_parent = $(this).closest('td');
				var productVariationsData = JSON.parse($current_element_parent.attr('data-product_variations'));

				console.log(productVariationsData);

				var select_inputs = $current_element_parent.find('select');
				if (current_select_value === 'Choose an option' || current_select_value === '' || current_select_value === null) {
					$(this).parent().addClass('af_wuc_prod_quantity_error');
				} else {
					$(this).parent('div').removeClass('af_wuc_prod_quantity_error');
				}

				select_inputs.each(
					function () {

						if ($(this).attr('name') !== current_element.attr('name')) {
							var other_select_name = 'attribute_' + $(this).attr('data-label');
							var other_select_value = $(this).val();

							if (other_select_value === 'Choose an option' || other_select_value === '' || other_select_value === null) {
								$(this).parent().addClass('af_wuc_prod_quantity_error');
								return false;
							} else {
								$(this).parent('div').removeClass('af_wuc_prod_quantity_error');
							}

						}
					}
				);

				var $parent_tr = current_element.closest('tr');
				// console.log( $parent_tr.find('af_wuc_prod_quantity_error'));

				if ($parent_tr.find('.af_wuc_prod_quantity_error').length == 0) {

					var form_data = new FormData();

					$parent_tr.find('select').each(
						function () {
							form_data.append('attributes[attribute_' + $(this).attr('data-label') + ']', $(this).val())
						}
					);

					form_data.append('product_id', $current_element_parent.attr('data-product_id'));
					form_data.append('nonce', nonce);
					form_data.append('action', 'af_wuc_get_stock_quantity');

					$.ajax(
						{
							type: 'post',
							url: ajaxurl,
							data: form_data,
							delay: 100,
							processData: false,
							contentType: false,
							cache: false,
							dataType: 'json',

							success: function (response) {
								if (!response.error) {
									console.log(response);

									var $input_quantity = $parent_tr.find('input.af_wuc_prod_quantity');
									$parent_tr.find('div.af_wuc_message').html(response.data.af_wuc_message);
									$input_quantity.attr('max', response.data.af_wuc_quantity);

									if (response.data.product_found !== true) {
										$input_quantity.prop('disabled', true);
										$parent_tr.find('div.af_wuc_message').addClass('af_wuc_prod_error');
									}

									else {
										if (response.data.af_wuc_manage_stock) {
											if (parseInt($input_quantity.val()) > response.data.af_wuc_quantity && response.data.af_wuc_quantity !== '') {
												$input_quantity.val(response.data.af_wuc_quantity);
											}
											if (response.data.af_wuc_quantity > 0) {
												$input_quantity.prop('disabled', false);
												$parent_tr.find('div.af_wuc_message').removeClass('af_wuc_prod_error');
											}
										}

										if (response.data.af_wuc_stock_status !== 'outofstock') {
											$input_quantity.prop('disabled', false);
											$parent_tr.find('div.af_wuc_message').removeClass('af_wuc_prod_error');
										} else {
											$input_quantity.prop('disabled', true);
											$parent_tr.find('div.af_wuc_message').addClass('af_wuc_prod_error');
										}
									}
								}
							},
						}
					);

					// var af_wuc_product_id =$current_element_parent.attr('data-product_id');

				}
			}
		);
		$(document).ready(function () {
			$('select.af_wuc_product_attribute').each(function () {
				$(this).trigger('change');
				return false;
			});
		});

		$(document).on(
			'click',
			'.af_wuc_close_button',
			function () {
				$(this).closest('tr').remove();
				if ($('.af-wuc-table').find('tbody tr').length == 0) {
					$('.af-wuc-table').closest('div').addClass('af-wuc-hide-table');
					$('.af_wuc_url_tr').toggle($('table.af-wuc-table tbody tr').length > 0);
					$('#publish').toggle($('table.af-wuc-table tbody tr').length > 0);
				}
			}
		);

		$('#publish').on(
			'click',
			function () {

				if ($('#title').val() === '') {
					alert('Please write the title of post');
					$('#title').focus();
					return false;
				}
				if ($('.af-wuc-table').find('tbody tr').length == 0 && $('.af-wuc-table').length > 0) {
					if ($('.af_wuc_url_tr')) {
						$('.af_wuc_url_tr').hide();
					}
					alert('Please Select atleast 1 product');
					return false;
				}
				var error_found = false;
				$('.af_wuc_product_attribute').each(
					function () {
						if ($(this).val() === 'Choose an option' || $(this).val() === '' || $(this).val() === null) {
							$(this).parent().addClass('af_wuc_prod_quantity_error');
							$(this).focus();
							error_found = true;
						}
					}
				);

				if ($('div.af_wuc_prod_error').length > 0) {
					error_found = true;
					$('html, body').animate(
						{
							scrollTop: $('table.af-wuc-table').offset().top
						},
						1000
					);
				}

				if (error_found) {
					return false;
				} else {
					if ($('.af_wuc_url_tr')) {
						$('.af_wuc_url_tr').show();
					}
				}

			}
		);

		$(document).on(
			"click",
			".af_wuc_share_btn_close",
			function () {
				$("#af_wuc_share_links_modal").addClass("af_wuc_share_links_hidden");
				$(".af_wuc_share_links_overlay").addClass("af_wuc_share_links_hidden");
			}
		);

		// close modal when the Esc key is pressed

		$(document).on(
			'keydown',
			function (e) {

				if (e.key === "Escape" && !$("#af_wuc_share_links_modal").hasClass("af_wuc_share_links_hidden")) {
					$(".af_wuc_share_btn_close").click();
				}
				if (e.key === "Escape" && !$(".af_wuc_order_table_modal").hasClass("af_wuc_hide")) {
					$(".af_wuc_order_table_btn_close").click();
				}

			}
		);

		$(document).on(
			'click',
			function (event) {

				if ($(event.target).closest("#af_wuc_share_links_modal").length == 0 && $(event.target).is("#af_wuc_share_links_modal") != true && $(event.target).is("#af_wuc_share_button") != true) {
					$(".af_wuc_share_btn_close").click();
				}
				if ($(event.target).closest(".af_wuc_order_table").length == 0 && $(event.target).is(".af_wuc_order_table_modal") != true && $(event.target).is(".af_wuc_check_orders") != true) {
					$(".af_wuc_order_table_btn_close").click();
				}
			}
		);

		$(window).on(
			"scroll",
			function () {
				var scrollPosition = $(window).scrollY;
				if (scrollPosition > 150) {
					$("#af_wuc_share_links_modal").css('top', "50%");
					$(".af_wuc_order_table_modal").css('top', "50%");
				} else {
					$("#af_wuc_share_links_modal").css('top', "calc(50% + " + 100 + "px)");
					$(".af_wuc_order_table_modal").css('top', "calc(50% + " + 100 + "px)");
				}
			}
		);

		// open modal function
		$(document).on(
			"click",
			"#af_wuc_share_button",
			function () {
				$("#af_wuc_generated_link").text($('#af_wuc_url').text());
				$(".af_wuc_share_links_modal").removeClass("af_wuc_share_links_hidden");
				$(".af_wuc_share_links_overlay").removeClass("af_wuc_share_links_hidden");
			}
		);

		$(document).on(
			"click",
			"#af_wuc_share_links_btn_copy_link",
			function (event) {
				var af_wuc_g_link_copy = $("#af_wuc_generated_link").text();

				af_wuc_copyToClipboard("#af_wuc_generated_link");
				alert("copied link:    " + af_wuc_g_link_copy);
			}
		);

	}
);

function af_wuc_copyToClipboard(element) {
	var $temp = jQuery("<input>");
	jQuery("body").append($temp);
	$temp.val(jQuery(element).text()).select();
	document.execCommand("copy");
	$temp.remove();
}

function af_wuc_social_media_link_function(self, url) {

	if (self.classList.contains("af_wuc_link_buttons_disabled")) {
		return;
	}

	jQuery("#af_wuc_share_links_btn_copy_link").click();
	setTimeout(
		function () {
			window.open(url, "_blank");
		}
		,
		500
	);
}
jQuery(document).ready(function ($) {
	// Target both #af_wuc_prefix and #wc_url_general_prefix
	$('#af_wuc_prefix, #wc_url_general_prefix, #af_wuc_prefix').on('input', function () {
		// Replace any space with an empty string
		this.value = this.value.replace(/\s+/g, '');
	});
});
jQuery(document).ready(function ($) {
	var defaultValue = 'af_wuc'; // Set your default value

	$('#wc_url_general_prefix').on('blur', function () {
		var currentValue = $(this).val().trim(); // Get current input value

		// If the input is empty, set it back to the default value
		if (currentValue === '') {
			$(this).val(defaultValue);
		}
	});
});



// JavaScript file: af-wuc.js
jQuery(document).ready(function ($) {
	$('a.af-wuc-url').on('click', function (e) {
		e.preventDefault(); // Prevent the default link behavior
		var couponUrl = $(this).attr('href'); // Get the clicked URL

		$.ajax({
			url: afWucData.ajax_url,
			type: 'POST',
			data: {
				action: 'af_wuc_add_products_to_cart',
				url_data: couponUrl,
				nonce: afWucData.nonce,
			},
			success: function (response) {
				if (response.success) {
					alert(response.data.message); // Show success message
					// Optionally reload the cart or update cart contents via AJAX here
				} else {
					alert(response.data.message); // Show error message
				}
			},
		});
	});
});
