<?php
$af_wuc_post_id = get_the_ID();

$af_wuc_products_stored_quantity = get_post_meta( $af_wuc_post_id, 'af_wuc_products_quantity', true );

$af_wuc_url_stored = get_post_meta( $af_wuc_post_id, 'af_wuc_url', true );

$af_wuc_coupon_stored = get_post_meta( $af_wuc_post_id, 'af_wuc_coupon', true );

$af_wuc_product_attribute_stored = get_post_meta( $af_wuc_post_id, 'af_wuc_product_attribute', true );

$af_wuc_product_variation_stored = get_post_meta( $af_wuc_post_id, 'af_wuc_product_variation', true );

$af_wuc_prefix = get_post_meta( $af_wuc_post_id, 'af_wuc_prefix', true );



$af_wuc_coupon_posts = get_posts(
	array(
		'orderby'     => 'datetime',
		'order'       => 'desc',
		'post_type'   => 'shop_coupon',
		'post_status' => 'publish',
		'numberposts' => - 1,
	)
);


wp_nonce_field( 'af-wuc-save-post', 'af_wuc_nonce' );
?>
<table class="wp-list-table widefat fixed table-view-list">
	<tbody>
	<tr>
		<th><strong><?php echo esc_html__( 'Select Coupon', 'addify-advanced-url-coupons' ); ?></strong></th>
		<td>
			<select name="af_wuc_coupon" class="af_wuc_select_coupon">
				<?php

				foreach ( $af_wuc_coupon_posts as $key => $af_wuc_coupon ) {
					$af_coupon_expiry    = get_post_meta( $af_wuc_coupon->ID, 'date_expires', true );
					$af_wuc_valid_coupon = empty( $af_coupon_expiry ) || $af_coupon_expiry > time();

					?>
					<option value="<?php echo esc_attr( $af_wuc_coupon->ID ); ?>"
						<?php
						echo ! $af_wuc_valid_coupon ? esc_attr__( 'disabled', 'addify-advanced-url-coupons' ) : '';
						echo $af_wuc_coupon->ID === (int) $af_wuc_coupon_stored ? esc_attr( ' selected' ) : '';
						?>
					>
						<?php
						echo esc_attr( $af_wuc_coupon->post_title );
						echo ! $af_wuc_valid_coupon ? esc_html__( ' (expired)', 'addify-advanced-url-coupons' ) : '';
						?>
					</option>
					<?php
				}
				?>
			</select><br>
			<p><?php echo esc_html__( 'Select coupon from above list', 'addify-advanced-url-coupons' ); ?></p>
		</td>
	</tr>
	<?php
	if ( ! empty( $af_wuc_url_stored ) && 'publish' === get_post_status( get_the_ID() ) ) {
		?>
	<tr class="af_wuc_url_tr">
		<th><strong><?php echo esc_html__( 'URL Prefix', 'addify-advanced-url-coupons' ); ?></strong></th>
		<td>

		<?php
		$af_wuc_post_id = get_the_ID();
		$general_prefix =  !empty( get_option('wc_url_general_prefix') ) ? get_option('wc_url_general_prefix') : 'af_wuc'; 
		
		$af_wuc_prefix = !empty(get_post_meta($af_wuc_post_id, 'af_wuc_prefix', true)) ? get_post_meta($af_wuc_post_id, 'af_wuc_prefix', true) :$general_prefix ;

		// Ensure $af_wuc_prefix is a string and not an array
		$af_wuc_prefix = is_array($af_wuc_prefix) ? '' : $af_wuc_prefix;
		
		if ('checkout_page' == get_option('wc_url_coupon_tab_redirect_to_page')) {
			$home_url = wc_get_page_permalink('checkout');
		} else {
			$home_url = wc_get_page_permalink('cart');
			
		}
		$prefix = !empty($af_wuc_prefix) ? $af_wuc_prefix . '-' : $general_prefix;

		$full_url  = !str_contains($home_url, '?') ? "$home_url?$prefix" : "$home_url&$prefix";
		$full_url .= ( !empty($af_wuc_prefix) ? '' : '-' ) . $af_wuc_post_id;
		?>

		<a href="<?php echo esc_url($full_url); ?>" target="_blank" id="<?php echo esc_attr($general_prefix); ?>_url">
			<?php echo esc_url($full_url); ?>
		</a>

		<form method="post">
			<input type="text" name="af_wuc_prefix" id="af_wuc_prefix"  
					placeholder="<?php echo esc_attr($general_prefix); ?>" 
					value="<?php echo isset($af_wuc_prefix) ? esc_attr($af_wuc_prefix) : ''; ?>"> <!-- Removed oninput attribute -->
			<p>Add custom prefix/slug</p>
		</form>



			<button class="button button-primary button-large" id="af_wuc_share_button" type="button"><?php echo esc_html__( 'Share', 'addify-advanced-url-coupons' ); ?></button>

			<p><?php echo esc_html__( 'Copy link to share with your customers. When customers visit using this link, it will automatically add the selected products to cart along with the selected products.', 'addify-advanced-url-coupons' ); ?></p>
			
			<!-- Modal content for sharing links -->
			<section tabindex="0" class="af_wuc_share_links_modal af_wuc_share_links_hidden" id="af_wuc_share_links_modal">
				<!-- Modal header -->
				<div class="af_wuc_share_links_modal_header">
					<h3><?php echo esc_html__( 'Available sharing platforms', 'addify-advanced-url-coupons' ); ?></h3>
					<button class="af_wuc_share_btn_close" type="button"><i class="fa fa-times"></i></button>
				</div>
				
				<!-- Modal body -->
				<div class="af_wuc_share_links_modal_body">
					<a href="#" onclick="af_wuc_social_media_link_function(this,'https://web.whatsapp.com/')"
						class="af_wuc_share_links_modal_body_icons af_wuc_share_link"><i class="fa-brands fa-whatsapp-square fa-lg"></i></a>
					<a href="#" onclick="af_wuc_social_media_link_function(this,'https://www.facebook.com/')"
						class="af_wuc_share_links_modal_body_icons af_wuc_share_link"><i class="fa-brands fa-facebook-square fa-lg"></i></a>
					<a href="#" onclick="af_wuc_social_media_link_function(this,'https://www.twitter.com/')"
						class="af_wuc_share_links_modal_body_icons af_wuc_share_link"><i class="fa-brands fa-twitter-square fa-lg"></i></a>
					<a href="#" class="af_wuc_share_links_modal_body_icons af_wuc_share_link"
						onclick="af_wuc_social_media_link_function(this,'mailto:')"><i class="fa-sharp fa-solid fa-square-envelope fa-lg"></i></a>
				</div>
				
				<!-- Modal footer -->
				<div class="af_wuc_share_links_modal_footer">
					<p class="af_wuc_generated_link" id="af_wuc_generated_link"><?php echo esc_html__( 'Generated link', 'addify-advanced-url-coupons' ); ?></p>
					<button type="button" class="button button-primary af_wuc_share_links_btn_copy_link af_wuc_share_link" id="af_wuc_share_links_btn_copy_link"><?php echo esc_html__( 'Copy link', 'addify-advanced-url-coupons' ); ?></button>
				</div>
			</section>
			
			<div class="af_wuc_share_links_overlay af_wuc_share_links_hidden"></div>
		</td>
	</tr>
	<?php } ?>

	<tr>
		<th><strong><?php echo esc_html__( 'Select Product', 'addify-advanced-url-coupons' ); ?></strong></th>

		<td><select name="af_wuc_products[]" multiple="multiple"
					class="af-wuc-product-live-search af_wuc_multi_select_products">
				<option></option>
			</select>
			<p><?php echo esc_html__( 'Select the products you want to automatically add to cart along with coupon. If these products are removed, the coupon will be removed', 'addify-advanced-url-coupons' ); ?></p>
			<button class="button button-primary button-large" id="af_wuc_add_quantity_for_product"
					type="button"><?php echo esc_html__( 'Add Product', 'addify-advanced-url-coupons' ); ?></button>
		</td>
	</tr>
	</tbody>
</table>

<div class="<?php echo empty( $af_wuc_products_stored_quantity ) ? 'af-wuc-hide-table' : ''; ?>">
	<h5><?php echo esc_html__( 'Add to Cart Products', 'addify-advanced-url-coupons' ); ?></h5>
	<table class="wp-list-table widefat fixed  table-view-list af-wuc-table af-wuc-added-product-table">
		<thead>
		<th class="af-wuc-table-td"><?php echo esc_html__( 'Product Name', 'addify-advanced-url-coupons' ); ?></th>
		<th class="af-wuc-table-td"><?php echo esc_html__( 'Set Quantity of Product', 'addify-advanced-url-coupons' ); ?></th>
		<th class="af-wuc-table-td"><?php echo esc_html__( 'Stock Availability', 'addify-advanced-url-coupons' ); ?></th>
		<th></th>
		</thead>
		<tbody>
		<?php
		foreach ( (array) $af_wuc_products_stored_quantity as $af_wuc_product_id => $af_wuc_single_product_quantity ) {
			$af_wuc_product_quantity_input = false;
			$af_wuc_single_product         = wc_get_product( $af_wuc_product_id );
			if ( $af_wuc_single_product ) {
				$af_wuc_product_attributes = array();
//              if ( 'variable' === $af_wuc_single_product->get_type() ) {
//
//                  foreach ( $af_wuc_single_product->get_available_variations() as $af_wuc_single_variation_product ) {
//                      $af_wuc_product_attributes[] = $af_wuc_single_variation_product['attributes'];
//                      $match                       = true;
//                  }
//
//                  $variation_product = wc_get_product( $af_wuc_product_variation_stored[ $af_wuc_product_id ]['variation_id'] );
//
//                  if ( $variation_product ) {
//                      $af_wuc_product_result = af_wuc_get_product_stock_quantity_and_status( $variation_product );
//
//                      if(empty($af_wuc_product_result['af_wuc_product_quantity_input'])){
//                          if('outofstock'!==$af_wuc_single_product->get_stock_status() && 'outofstock'!==$variation_product->get_stock_status()){
//                              $af_wuc_product_result['af_wuc_product_stock_message']   = esc_html__( 'Available Quantity ', 'addify-advanced-url-coupons' );
//                              $af_wuc_product_result['af_wuc_product_sold_individual'] = $af_wuc_single_product->get_sold_individually();
//                              if ( 'yes'===get_post_meta($af_wuc_single_product->get_id(),'_manage_stock',true) && empty($af_wuc_product_result['af_wuc_product_stock_quantity']) ) {
//                                  $af_wuc_product_result['af_wuc_product_stock_quantity']=  esc_html__(  $af_wuc_single_product->get_stock_quantity(), 'addify-advanced-url-coupons' );
//                              }
//                          }
//                      }
//                  }
////                    else{
////                        $af_wuc_product_result['af_wuc_product_stock_quantity']='';
////                        $af_wuc_product_result['af_wuc_product_stock_message']   = esc_html__( 'This variation is not available ', 'addify-advanced-url-coupons' );
////                    }
//              }
//              else {

					$af_wuc_product_result = af_wuc_get_product_stock_quantity_and_status( $af_wuc_single_product );

//              }
				?>
				<tr>
					<th class="af-wuc-table-td">
						<b><a href="<?php echo esc_url( get_edit_post_link( $af_wuc_product_id ) ); ?>"> 
							<?php echo esc_html( $af_wuc_single_product->get_name() ); ?>
						</a></b>
					</th>

					<td class="af-wuc-table-td"><input
								type="number"
								name="af_wuc_products_quantity[<?php echo esc_attr( $af_wuc_product_id ); ?>]"
								required="required"
								min="1"
								max=""
								value="<?php echo esc_attr( $af_wuc_single_product_quantity ); ?>"
								class="af_wuc_prod_quantity af_wuc_prod_quantity_<?php echo esc_attr( $af_wuc_product_id ); ?>"
							<?php
							if ( $af_wuc_product_result['af_wuc_product_quantity_input'] ) {
								echo 'disabled';
							}
							?>
						>
					</td>
					<td class="af-wuc-table-td" data-product_id="<?php echo esc_attr( $af_wuc_product_id ); ?>"
						data-product_variations="
<?php echo esc_attr( wp_json_encode( ( $af_wuc_product_attributes ) ) ); ?>
">
						<?php
						if ( 'variable' === $af_wuc_single_product->get_type() ) {
							foreach ( $af_wuc_single_product->get_attributes() as $key => $attribute ) {
								$attribute_name = strtolower( $attribute['name'] );
								$selected_class = empty( $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ) || 'Choose an option' === $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ? '' : 'af-wuc-selected-attribute';
								?>
						<div class="af_wuc_attribute_inputs ">
							<strong><?php echo esc_html( wc_attribute_label( $attribute['name'] ) ); ?>:&nbsp;</strong>

							<select class="af_wuc_product_attribute <?php echo esc_attr( $selected_class ); ?>"
									name="af_wuc_product_attribute[<?php echo esc_attr( $af_wuc_product_id ); ?>][<?php echo esc_attr( $attribute_name ); ?>]"
									data-label="<?php echo esc_attr( strtolower( $key ) ); ?>"
									data-value="<?php echo isset( $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ) ? esc_attr( $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ) : ''; ?>">
								<option value="<?php echo esc_attr( 'Choose an option' ); ?>"><?php echo esc_html__( 'Choose an option', 'addify-advanced-url-coupons' ); ?></option>
								<?php
								foreach ( $attribute['options'] as $term_key => $term_id ) {
									$get_term = get_term( $term_id );
									if ( ! $get_term ) {
										?>
										<option value="<?php echo esc_attr( $term_id ); ?>" <?php echo isset( $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ) && $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] === $term_id ? 'selected' : ''; ?>>
											<?php echo esc_html( $term_id ); ?>
										</option>
										<?php
									} else {
										?>
										<option value="<?php echo esc_attr( $get_term->slug ); ?>" <?php echo isset( $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] ) && $af_wuc_product_attribute_stored[ $af_wuc_product_id ][ $attribute_name ] === $get_term->slug ? 'selected' : ''; ?>>
											<?php echo esc_html( $get_term->name ); ?>
										</option>
										<?php
									}
								}

								echo '</select></div><br>';
							}
						}
						?>
								<div class="af_wuc_message <?php echo $af_wuc_product_result['af_wuc_product_quantity_input'] ? esc_attr( 'af_wuc_prod_error' ) : ''; ?> ">
									<?php
									if ( 'variable' !== $af_wuc_single_product->get_type() ) {

										echo esc_attr( $af_wuc_product_result['af_wuc_stock_status'] );
										if ( $af_wuc_product_result['af_wuc_product_sold_individual'] ) {
											echo '<br>';
											echo esc_html( sprintf( '%s = 1', $af_wuc_product_result['af_wuc_product_stock_message'] ) );
										} elseif ( isset( $af_wuc_product_result['af_wuc_product_stock_quantity'] ) ) {
											echo '<br>';
											echo esc_html( sprintf( '%s = %d', $af_wuc_product_result['af_wuc_product_stock_message'], $af_wuc_product_result['af_wuc_product_stock_quantity'] ) );
										}

									}
									?>
								</div>
					</td>
					<td class="af-wuc-table-td"><b><i class="fa fa-trash af_wuc_close_button"
														title="Remove this Product"></i></b></td>
				</tr>

				<?php
			}
		}
		?>
		</tbody>
	</table>

</div>