<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class AF_WUC_Block_Class {

	public function __construct() {
		add_action('wp_enqueue_scripts', array( $this, 'enqueue_af_wuc_scripts' ));
	}
	public function enqueue_af_wuc_scripts() {
		// Enqueue the frontend script
		wp_enqueue_script('addify_wuc_front', AF_WUC_URL . '/assets/js/af-wuc-front-script.js', array( 'jquery' ), '1.0.0', false);
	
		$coupon_messages = WC()->session->get('coupon_messages');

		// Check if there are any messages and ensure it's an array
		if (!empty($coupon_messages) && is_array($coupon_messages)) {
			// Loop through the messages by type (success or error)
			foreach ($coupon_messages as $message_type => $messages) {
				if (is_array($messages)) {
					foreach ($messages as $message) {
						if ( has_block('woocommerce/cart') || has_block('woocommerce/checkout') ) {
							if ('success' === $message_type) { ?>
								<div class="wc-block-store-notice wc-block-components-notice-banner is-success" role="alert">
									<div class="wc-block-components-notices">
										<?php echo wp_kses(( $message ), af_acu_allowed_html_tags()); ?>

									</div>
								</div>
							<?php } elseif ('error' === $message_type) { ?>
								<div class="wc-block-store-notice wc-block-components-notice-banner is-error" role="alert">
									<div class="wc-block-components-notices">
										<?php echo wp_kses(( $message ), af_acu_allowed_html_tags()); ?>
									</div>
								</div>
							<?php
							}
						}
					}
				}
			}

			// Clear the session after displaying the messages (optional)
			WC()->session->__unset('coupon_messages');
		}


		$messages = WC()->session->get('af_wuc_messages');

		if ( is_checkout() || is_cart() ) {
			if ( !empty($messages) ) {
				foreach ( $messages as $message ) {
					if ( has_block('woocommerce/cart') || has_block('woocommerce/checkout') ) {
						?>
				<div class="wc-block-store-notice wc-block-components-notice-banner is-success" role="alert">
					<div class="wc-block-components-notices">
								<?php echo wp_kses(( $message ), af_acu_allowed_html_tags()); ?>
					</div>
				</div>
					<?php } else { ?>
				<div class="woocommerce">
					<div class="woocommerce-notices-wrapper">
						<div class="woocommerce-message" role="alert">
							<?php echo wp_kses(( $message ), af_acu_allowed_html_tags()); ?>
						</div>
					</div>
				</div>
			<?php
					}
				}

				// Clear the session messages after displaying them
				WC()->session->__unset('af_wuc_messages');
			}
		}
	}
}

new AF_WUC_Block_Class();