<?php
function af_wuc_get_product_stock_quantity_and_status( $af_wuc_product ) {
	$af_wuc_product_result = array();

	// Process availability class without using esc_html__
	$availability_class = ucwords( str_replace( '-', ' ', $af_wuc_product->get_availability()['class'] ) );
	// Escape dynamically generated value (no translation needed)
	$af_wuc_product_result['af_wuc_stock_status'] = esc_html( $availability_class );

	$af_wuc_product_result['af_wuc_product_sold_individual'] = false;
	$af_wuc_product_result['af_wuc_product_quantity_input']  = false;

	if ( 'outofstock' !== $af_wuc_product->get_stock_status() ) {
		// Translate literal string 'Available Quantity'
		$af_wuc_product_result['af_wuc_product_stock_message']   = esc_html__( 'Available Quantity ', 'addify-advanced-url-coupons' );
		$af_wuc_product_result['af_wuc_product_sold_individual'] = $af_wuc_product->get_sold_individually();

		if ( 'yes' === get_post_meta( $af_wuc_product->get_id(), '_manage_stock', true ) ) {
			// Escape stock quantity directly (no translation needed)
			$af_wuc_product_result['af_wuc_product_stock_quantity'] = esc_html( $af_wuc_product->get_stock_quantity() );
		}
	} else {
		$af_wuc_product_result['af_wuc_product_quantity_input'] = true;
	}

	return $af_wuc_product_result;
}

function af_acu_allowed_html_tags() {
	$allowed_html = array(
		'a'          => array(
			'href'   => array(),
			'title'  => array(),
			'target' => array(),
			'rel'    => array(), // Allow 'rel' attribute for links (e.g., 'nofollow')
		),
		'abbr'       => array(
			'title' => array(),
		),
		'acronym'    => array(
			'title' => array(),
		),
		'b'          => array(),
		'blockquote' => array(
			'cite' => array(),
		),
		'br'         => array(),
		'cite'       => array(),
		'code'       => array(),
		'del'        => array(
			'datetime' => array(),
		),
		'em'         => array(),
		'i'          => array(),
		'img'        => array(
			'src'     => array(),
			'alt'     => array(),
			'width'   => array(),
			'height'  => array(),
			'title'   => array(),
			'loading' => array(), // Allow 'loading' attribute for lazy loading images
		),
		'q'          => array(
			'cite' => array(),
		),
		's'          => array(),
		'strike'     => array(),
		'strong'     => array(),
		'u'          => array(), // Allow <u> for underlined text
		'ul'         => array(),
		'ol'         => array(),
		'li'         => array(),
		'table'      => array(),
		'thead'      => array(),
		'tbody'      => array(),
		'tfoot'      => array(),
		'tr'         => array(),
		'td'         => array(),
		'th'         => array(),
		'caption'    => array(),
		'span'       => array(),
		'div'        => array(
			'class' => array(),
			'id'    => array(),
			'style' => array(), // Allow inline styles in divs
		),
		'p'          => array(),
		'pre'        => array(),
		'h1'         => array(),
		'h2'         => array(),
		'h3'         => array(),
		'h4'         => array(),
		'h5'         => array(),
		'h6'         => array(),
		'iframe'     => array(
			'src'             => array(),
			'width'           => array(),
			'height'          => array(),
			'frameborder'     => array(),
			'allowfullscreen' => array(),
		),
		'video'      => array(
			'src'      => array(),
			'controls' => array(),
			'width'    => array(),
			'height'   => array(),
			'poster'   => array(),
		),
		'audio'      => array(
			'src'      => array(),
			'controls' => array(),
			'autoplay' => array(),
			'loop'     => array(),
		),
		'source'     => array(
			'src'  => array(),
			'type' => array(),
		),
		'link'       => array(
			'rel'   => array(),
			'href'  => array(),
			'type'  => array(),
			'sizes' => array(),
		),
		'meta'       => array(
			'name'       => array(),
			'content'    => array(),
			'charset'    => array(),
			'http-equiv' => array(),
		),
		'style'      => array(), // Allow <style> tags (but beware of security risks)
		'script'     => array(
			'src'   => array(),
			'type'  => array(),
			'async' => array(),
			'defer' => array(),
		),
		'font'       => array(
			'color' => array(),
		),
		'mark'       => array(),
		'sub'        => array(),
		'sup'        => array(),
		'ins'        => array(
			'datetime' => array(),
		),
		'small'      => array(),
		'big'        => array(),
		'bdi'        => array(),
		'bdo'        => array(),
		'wbr'        => array(),
		'address'    => array(),
		'center'     => array(),
		'details'    => array(),
		'summary'    => array(),
		'meter'      => array(),
		'progress'   => array(),
		'template'   => array(),
		'noscript'   => array(),
	);


return $allowed_html;
}
